﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;

namespace Summary
{
    public partial class Form1 : Form
    {
        private const int ROWS = 100;
        private const int COLS = 10;

        private DataTable table = null;

        public Form1()
        {
            this.InitializeComponent();
            this.grid.TextRenderingMode = TextRenderingMode.GDI;
            this.grid.Font = new Font(this.Font.FontFamily, 12f);
            this.grid.InitializeLayout += new InitializeLayoutEventHandler(grid_InitializeLayout);
            this.grid.DataSource = this.Table;

            this.grid.BeforeCellActivate += new CancelableCellEventHandler(grid_BeforeCellActivate);
        }

        void grid_BeforeCellActivate(object sender, CancelableCellEventArgs e)
        {
            if ( e.Cell.Column.Key == "FormattedText" )
                e.Cancel = true;
        }

        void grid_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns["FormattedText"].Editor =
                new Infragistics.Win.FormattedLinkLabel.FormattedLinkEditor(true);
        }

        private DataTable Table
        {
            get
            {
                if ( this.table == null )
                {
                    this.table = new DataTable();


                    this.table.Columns.Add("Name", typeof(string));
                    this.table.Columns.Add("Number", typeof(int));
                    this.table.Columns.Add("FormattedText", typeof(string));

                    this.table.Rows.Add( new object[]{ "One", 1, "This text is <span style=\"color: #FF0000;\">RED</span>" } );
                    this.table.Rows.Add( new object[]{ "Two", 2, "This text is <span style=\"color: #008000;\">GREEN</span>" } );
                    this.table.Rows.Add( new object[]{ "Three", 3, "This text is <span style=\"color: #0000FF;\">BLUE</span>" } );
                }

                return this.table;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.grid.DisplayLayout.Bands[0].Columns["FormattedText"].CellActivation = Activation.ActivateOnly;
        }

    }

}
